InvenArmory = CreateFrame("Frame")
InvenArmory:SetScript("OnEvent", function(self, event, ...) if self[event] then self[event](self, ...) end end)
if not BluePrint then function BluePrint() end end

local _G = _G
local type = _G.type
local select = _G.select
local strfind = _G.strfind
local strmatch = _G.strmatch
local strupper = _G.strupper
local GetBuildInfo = _G.GetBuildInfo
local GetNumTalents = _G.GetNumTalents
local GetTalentInfo = _G.GetTalentInfo
local GetTalentLink = _G.GetTalentLink
local GetTalentPrereqs = _G.GetTalentPrereqs
local UnitClass = _G.UnitClass
local UnitLevel = _G.UnitLevel
local UnitName = _G.UnitName
local UnitFactionGroup = _G.UnitFactionGroup
local NotifyInspect = _G.NotifyInspect
local CheckInteractDistance = _G.CheckInteractDistance
local GetFriendInfo = _G.GetFriendInfo
local GetGuildRosterInfo = _G.GetGuildRosterInfo
local GetTime = _G.GetTime

local RC = LibStub("LibRaidComm-1.0")
local hooks = {}
local useRC = {}
local skipPlayer = {}
local tellPlayer = {}
local classKR = { "전사", "드루이드", "성기사", "사제", "주술사", "도적", "마법사", "흑마법사", "사냥꾼", "죽음의 기사" }
local classToID = { ["전사"] = 1, ["드루이드"] = 2, ["성기사"] = 3, ["사제"] = 4, ["주술사"] = 5, ["도적"] = 6, ["마법사"] = 7, ["흑마법사"] = 8, ["사냥꾼"] = 9, ["죽음의 기사"] = 10 }
local language = { ["오크어"] = "호드", ["타우렌어"] = "호드", ["언데드어"] = "호드", ["하이엘프어"] = "호드", ["트롤어"] = "호드", ["공용어"] = "얼라이언스", ["나이트 엘프어"] = "얼라이언스", ["드워프어"] = "얼라이언스", ["노움어"] = "얼라이언스", ["드레나이어"] = "얼라이언스" }
local tooltipSaveMode = false

local blinkfunc = function() end
local pname, name, icon, tier, column, dtier, dcolumn, currentRank, maxRank, link, playerClass, playerID, playerFaction, build, checkTalent, toCheck, n, connected, menu, iaButtonIndex, dropdownMenu

local function CheckArg(arg, types)
	return arg and type(arg) == (types or "string")
end

function InvenArmory:OnInit()
	self.version = GetAddOnMetadata("InvenArmory", "Version")
	self.userDB = {}
	self.DeleteDB = CreateFrame("Frame")
	self.DeleteDB.prevtime = GetTime()
	self.DeleteDB:SetScript("OnUpdate", function(self)
		self.timer = GetTime() - self.prevtime
		if self.timer > 1 then
			self.prevtime = GetTime()
			for p, v in pairs(InvenArmory.userDB) do
				if v.timer < self.prevtime then
					InvenArmory.userDB[p] = nil
				end
			end
		end
	end)
	self:RegisterEvent("CHAT_MSG_SAY")
	self:RegisterEvent("CHAT_MSG_YELL")
	self:RegisterEvent("CHAT_MSG_SYSTEM")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	UnitPopupButtons["INVENARMORY_INSPECT"] = { text = "인벤 전투정보실", dist = 0 }
	tinsert(UnitPopupMenus["FRIEND"], 1, "INVENARMORY_INSPECT")
	tinsert(UnitPopupMenus["PARTY"], 1, "INVENARMORY_INSPECT")
	tinsert(UnitPopupMenus["RAID"], 1, "INVENARMORY_INSPECT")
	tinsert(UnitPopupMenus["PLAYER"], 1, "INVENARMORY_INSPECT")
	tinsert(UnitPopupMenus["TEAM"], 1, "INVENARMORY_INSPECT")
	hooks.UnitPopup_HideButtons = UnitPopup_HideButtons
	UnitPopup_HideButtons = self.UnitPopup_HideButtons
	hooks.UnitPopup_OnClick = UnitPopup_OnClick
	UnitPopup_OnClick = self.UnitPopup_OnClick
	if IsLoggedIn() then
		InvenArmory:PLAYER_LOGIN()
	else
		InvenArmory:RegisterEvent("PLAYER_LOGIN")
	end
end

function InvenArmory:PLAYER_LOGIN()
	self:UnregisterEvent("PLAYER_LOGIN")
	playerClass = UnitClass("player")
	playerID = classToID[playerClass]
	RC.RegisterCallback(self, "LibRaidComm_InspectCheck", "Inspect")
	RC.RegisterCallback(self, "LibRaidComm_Talent", "Talent")
	RC.RegisterCallback(self, "LibRaidComm_Stat", "Stat")
	RC.RegisterCallback(self, "LibRaidComm_Info", "Info")
	RC.RegisterCallback(self, "LibRaidComm_Busy", "Busy")
	RC.RegisterCallback(self, "LibRaidComm_Deny", "Deny")
	for p, v in pairs(UnitPopupMenus) do
		for i = 1, #v do
			if v[i] == "SET_FOCUS" then
				tremove(UnitPopupMenus[p], i)
				break
			end
		end
	end
	for i = 1, #UnitPopupMenus.FRIEND do
		if UnitPopupMenus.FRIEND[i] == "TARGET" then
			tremove(UnitPopupMenus.FRIEND, i)
			break
		end
	end
end

function InvenArmory:PLAYER_ENTERING_WORLD()
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	if tooltipSaveMode then
		InvenArmoryDB = InvenArmoryDB or {}
		for p, v in pairs(InvenArmoryDB) do
			InvenArmoryTalentDB[p] = v
		end
		self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
		self:RegisterEvent("INSPECT_TALENT_READY")
	else
		InvenArmoryDB = nil
	end
end

function InvenArmory:UnitPopup_HideButtons()
	hooks.UnitPopup_HideButtons()
	dropdownMenu = UIDropDownMenu_GetCurrentDropDown()
	for index, value in ipairs(UnitPopupMenus[dropdownMenu.which]) do
		if value == "INVENARMORY_INSPECT" then
			name = nil
			if dropdownMenu.unit and UnitExists(dropdownMenu.unit) then
				if UnitIsPlayer(dropdownMenu.unit) and UnitFactionGroup(dropdownMenu.unit) == UnitFactionGroup("player") then
					name = GetUnitName(dropdownMenu.unit)
				else
					skipPlayer[GetUnitName(dropdownMenu.unit)] = true
				end
			elseif dropdownMenu.name then
				name = dropdownMenu.name
			end
			if name and skipPlayer[name] == nil then
				UnitPopupShown[UIDROPDOWNMENU_MENU_LEVEL][index] = 1
			else
				UnitPopupShown[UIDROPDOWNMENU_MENU_LEVEL][index] = 0
			end
			return
		end
	end
end


function InvenArmory:UnitPopup_OnClick()
	if this.value == "INVENARMORY_INSPECT" then
		if not InvenArmory.inspectName then
			dropdownMenu = UIDropDownMenu_GetCurrentDropDown()
			name = dropdownMenu.unit and GetUnitName(dropdownMenu.unit) or dropdownMenu.name
			InvenArmory:Send(name)
		end
	else
		hooks.UnitPopup_OnClick(self, self)
	end
end

function InvenArmory:Send(name)
	if name then
		if RC:IsDeny() then
			self.userDB = {}
			ChatFrame1:AddMessage("|cffa0a0ff인벤 전투정보실|r: 정보 수집 거부 상태에서는 다른 사람의 정보를 확인할 수 없습니다. 다른 사람의 정보를 확인하려면 |cffffff00게임 설정 ▷ 인터페이스 설정 ▷ 애드온 ▷ 인벤 전투정보실|r 항목에서 |cffffff00정보 수집 허용|r을 체크하세요.")
		else
			self.inspectName = name
			self.inspectFail = GetTime() + 1
			if self.userDB[name] then
				self.requestPlayer = nil
				if self.userDB[name].items then
					self:Inspect(nil, name, self.userDB[name].items)
				end
				if self.userDB[name].talent then
					self:Talent(nil, name, self.userDB[name].talent)
				end
				if self.userDB[name].stat then
					self:Stat(nil, name, unpack(self.userDB[name].stat))
				end
				if self.userDB[name].level then
					self:Info(nil, name, self.userDB[name].level, self.userDB[name].class, self.userDB[name].race)
				end
			else
				self.requestPlayer = true
				RC:Inspect(name)
				self:SetScript("OnUpdate", self.OnUpdate)
			end
		end
	end
end

function InvenArmory:OnUpdate()
	if InvenArmory.inspectName and self.inspectFail then
		if self.inspectFail < GetTime() then
			ChatFrame1:AddMessage("|cffa0a0ff인벤 전투정보실|r: |cffffff00"..self.inspectName.."|r님은 장비를 볼 수 있는 애드온을 사용하고 있지 않거나 너무 많은 정보 요청으로 인해 지연 중인 상태입니다.")
			InvenArmory.inspectName = nil
			InvenArmory.inspectFail = nil
			self:SetScript("OnUpdate", nil)
		end
	else
		self:SetScript("OnUpdate", nil)
	end
end

function InvenArmory:Busy(event, sender)
	if self.inspectName == sender then
		ChatFrame1:AddMessage("|cffa0a0ff인벤 전투정보실|r: 너무 많은 정보 요청으로 인해 잠시 지연 중입니다. 잠시 후에 시도하세요.")
		self.inspectName = nil
		self.inspectFail = nil
	end
end

function InvenArmory:Deny(event, sender)
	if self.inspectName == sender then
		ChatFrame1:AddMessage("|cffa0a0ff인벤 전투정보실|r: |cffffff00"..self.inspectName.."|r님은 정보 수집 거부 상태입니다.")
		self.inspectName = nil
		self.inspectFail = nil
	end
end

function InvenArmory:CHAT_MSG_SAY(msg, sender, lang)
	playerFaction = playerFaction or select(2, UnitFactionGroup("player"))
	if language[lang] ~= playerFaction then
		skipPlayer[sender] = true
	end
end

function InvenArmory:CHAT_MSG_YELL(...)
	self:CHAT_MSG_SAY(...)
end

function InvenArmory:CHAT_MSG_SYSTEM(msg)
	msg = strmatch(msg, "현재 (.+)|1이라는;라는; 플레이어는 게임에 접속해 있지 않습니다.")
	if msg and InvenArmory.inspectName and self.inspectFail then
		InvenArmory.inspectName = nil
		InvenArmory.inspectFail = nil
		self:SetScript("OnUpdate", nil)
	end
end

function InvenArmory:GetPlayerClassID(name)
	if name and useRC[name] and type(useRC[name]) == "number" then
		return useRC[name]
	else
		return nil
	end
end

if tooltipSaveMode then
	function InvenArmory:UPDATE_MOUSEOVER_UNIT()
		InvenArmoryDB = InvenArmoryDB or {}
		self:UpdateUnitTalentDB("mouseover")
	end

	function InvenArmory:UpdateUnitTalentDB(unit)
		if unit and UnitExists(unit) and UnitIsPlayer(unit) and UnitClass(unit) then
			n = classToID[UnitClass(unit)]
			if not toCheck and n and InvenArmoryDB[n] == nil and UnitLevel(unit) > 10 and CheckInteractDistance(unit, 1) then
				BluePrint("3")
				if UnitIsUnit(unit, "player") then
					self:SaveTalentLink(n)
				else
					toCheck = n
					NotifyInspect(unit)
				end
			end
		end
	end

	function InvenArmory:INSPECT_TALENT_READY()
		if toCheck then
			self:SaveTalentLink(toCheck, true)
			toCheck = nil
		end
	end

	function InvenArmory:SaveTalentLink(index, isInspect)
		if InvenArmoryDB[index] == nil then
			InvenArmoryDB[index] = {}
			for i = 1, 3 do
				n = GetNumTalents(i, isInspect)
				local name, _, _, background = GetTalentTabInfo(i, isInspect)
				InvenArmoryDB[index][i] = { name = name, bg = background }
				for j = 1, n do
					local nameTalent, icon, tier, column = GetTalentInfo(i, j, isInspect)
					icon = gsub(icon, "Interface\\Icons\\", "")
					local link = tonumber(strmatch(GetTalentLink(i, j, isInspect), "talent:(%d+)"))
					InvenArmoryDB[index][i][j] = format("%s#%s#%d#%d#%d", nameTalent, icon, tier, column, link)
					dtier, dcolumn = GetTalentPrereqs(i, j, isInspect)
					if dtier and dcolumn then
						InvenArmoryDB[index][i].prereqs = (InvenArmoryDB[index][i].prereqs and (InvenArmoryDB[index][i].prereqs.."#") or "")..format("%d:%d|%d:%d", tier, column, dtier, dcolumn)
					end
				end
			end
			InvenArmoryTalentDB[index] = InvenArmoryDB[index]
		end
	end
end

InvenArmory:OnInit()